#include "../../src/Library/Natures/NatureLibrary.hpp"
#include "../Core.hpp"
using namespace PkmnLib::Library;

export_func NatureLibrary* PkmnLib_NatureLibrary_Construct(size_t initialCapacity) {
    return new NatureLibrary(initialCapacity);
}
export_func void PkmnLib_NatureLibrary_Destruct(const NatureLibrary* p) { delete p; }

export_func uint8_t PkmnLib_NatureLibrary_LoadNature(NatureLibrary* p, const char* name, const Nature* nature) {
    Try(p->LoadNature(ArbUt::StringView(name), nature);)
}
export_func uint8_t PkmnLib_NatureLibrary_GetNatureByName(NatureLibrary* p, const char* name, const Nature*& out) {
    Try(out = p->GetNatureByName(ArbUt::StringView(name)).GetRaw());
}

export_func uint8_t PkmnLib_NatureLibrary_GetRandomNatureName(NatureLibrary* p, ArbUt::Random* rand, const char*& out) {
    Try(out = p->GetRandomNatureName(*rand).c_str();)
}

export_func uint8_t PkmnLib_NatureLibrary_GetNatureName(NatureLibrary* p, const Nature* nature, const char*& out) {
    Try(out = p->GetNatureName(nature).c_str());
}

SIMPLE_GET_FUNC(NatureLibrary, GetNatureCount, size_t)
export_func uint8_t PkmnLib_NatureLibrary_GetNatureByIndex(NatureLibrary* p, size_t index, const char*& out) {
    Try(out = p->GetNatureFromIndex(index).c_str();)
}