#ifndef PKMNLIB_WEATHERCHANGEEVENT_HPP
#define PKMNLIB_WEATHERCHANGEEVENT_HPP
#include <CreatureLib/Battling/EventHooks/Events/EventData.hpp>
#include "PkmnEventKind.hpp"

namespace PkmnLib::Battling {
    class WeatherChangeEvent final : public CreatureLib::Battling::EventData {
        ArbUt::StringView _weatherName;

    public:
        explicit WeatherChangeEvent(const ArbUt::StringView& name) : _weatherName(name) {}

        [[nodiscard]] CreatureLib::Battling::EventDataKind GetKind() const noexcept override {
            return static_cast<CreatureLib::Battling::EventDataKind>(PkmnEventDataKind::WeatherChange);
        }

        const ArbUt::StringView& GetWeatherName() const noexcept { return _weatherName; }
    };
}

#endif // PKMNLIB_WEATHERCHANGEEVENT_HPP
