#ifndef PKMNLIB_ITEM_HPP
#define PKMNLIB_ITEM_HPP

#include <CreatureLib/Library/Items/Item.hpp>
namespace PkmnLib::Library {
    class Item final : public CreatureLib::Library::Item {
        u8 _flingPower;

    public:
        Item(const ArbUt::StringView& name, CreatureLib::Library::ItemCategory category,
             CreatureLib::Library::BattleItemCategory battleCategory, int32_t price,
             const CreatureLib::Library::SecondaryEffect* nullable effect,
             const CreatureLib::Library::SecondaryEffect* nullable battleTriggerEffect,
             const std::unordered_set<uint32_t>& flags, u8 flingPower) noexcept
            : CreatureLib::Library::Item(name, category, battleCategory, price, battleTriggerEffect, effect, flags),
              _flingPower(flingPower) {}

        inline u8 GetFlingPower() const noexcept { return _flingPower; }
    };
}

#endif // PKMNLIB_ITEM_HPP
