#include "RegisterBattleLibrary.hpp"
#include "../../../../Battling/Library/BattleLibrary.hpp"
#include "../HelperFile.hpp"

void RegisterBattleLibrary::Register(asIScriptEngine* engine) {
    RegisterDamageLibrary(engine);
    RegisterLibrary(engine);
}
void RegisterBattleLibrary::RegisterDamageLibrary(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("DamageLibrary", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0)
}

void RegisterBattleLibrary::RegisterLibrary(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("BattleLibrary", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0);

    REGISTER_GETTER("BattleLibrary", "const LibrarySettings@ get_Settings() const property",
                    PkmnLib::Battling::BattleLibrary, GetSettings);
    REGISTER_GETTER("BattleLibrary", "const StaticLibrary@ get_StaticLibrary() const property",
                    PkmnLib::Battling::BattleLibrary, GetStaticLib);
    REGISTER_GETTER("BattleLibrary", "const SpeciesLibrary@ get_SpeciesLibrary() const property",
                    PkmnLib::Battling::BattleLibrary, GetSpeciesLibrary);
    REGISTER_GETTER("BattleLibrary", "const MoveLibrary@ get_MoveLibrary() const property",
                    PkmnLib::Battling::BattleLibrary, GetMoveLibrary);
    REGISTER_GETTER("BattleLibrary", "const ItemLibrary@ get_ItemLibrary() const property",
                    PkmnLib::Battling::BattleLibrary, GetItemLibrary);
    REGISTER_GETTER("BattleLibrary", "const DamageLibrary@ get_DamageLibrary() const property",
                    CreatureLib::Battling::BattleLibrary, GetDamageLibrary);
}
