#include "RegisterStaticLibraryTypes.hpp"
#include "../../../../Library/PokemonLibrary.hpp"
#include "../HelperFile.hpp"

void RegisterStaticLibraryTypes::Register(asIScriptEngine* engine) {
    RegisterLibrarySettingsType(engine);
    RegisterLibraryType(engine);
}

void RegisterStaticLibraryTypes::RegisterLibrarySettingsType(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("LibrarySettings", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0);
    REGISTER_GETTER("LibrarySettings", "uint8 get_MaximalLevel() const property", CreatureLib::Library::LibrarySettings,
                    GetMaximalLevel);
    REGISTER_GETTER("LibrarySettings", "uint8 get_MaximalMoves() const property", CreatureLib::Library::LibrarySettings,
                    GetMaximalAttacks);
    REGISTER_GETTER("LibrarySettings", "uint16 get_ShinyRate() const property", PkmnLib::Library::LibrarySettings,
                    GetShinyRate);
}

void RegisterStaticLibraryTypes::RegisterLibraryType(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("StaticLibrary", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0);
    REGISTER_GETTER("StaticLibrary", "const LibrarySettings@ get_Settings() const property",
                    CreatureLib::Library::DataLibrary, GetSettings);
    REGISTER_GETTER("StaticLibrary", "const SpeciesLibrary@ get_SpeciesLibrary() const property",
                    CreatureLib::Library::DataLibrary, GetSpeciesLibrary);
    REGISTER_GETTER("StaticLibrary", "const MoveLibrary@ get_MoveLibrary() const property",
                    CreatureLib::Library::DataLibrary, GetAttackLibrary);
    REGISTER_GETTER("StaticLibrary", "const ItemLibrary@ get_ItemLibrary() const property",
                    CreatureLib::Library::DataLibrary, GetItemLibrary);
    REGISTER_GETTER("StaticLibrary", "const GrowthRateLibrary@ get_GrowthRateLibrary() const property",
                    CreatureLib::Library::DataLibrary, GetGrowthRates);
    REGISTER_GETTER("StaticLibrary", "const TypeLibrary@ get_TypeLibrary() const property",
                    CreatureLib::Library::DataLibrary, GetTypeLibrary);
}
