#ifndef PKMNLIB_TYPEREGISTRY_HPP
#define PKMNLIB_TYPEREGISTRY_HPP

#include <string>
#include "../WebAssemblyScriptResolver.hpp"
#include "Arbutils/Collections/Dictionary.hpp"
#include "Library/LibraryMethods.hpp"
#include "Library/WASMMoveDataRegistry.hpp"
#include "WASMCoreMethods.hpp"
#include "WASMStringView.hpp"

class TypeRegistry {
public:
    static void Register(ArbUt::Dictionary<std::string, wasm_func_t*>& externs, WebAssemblyScriptResolver* resolver) {
        WASMCoreMethods::Register(externs, resolver);
        WASMStringView::Register(externs, resolver);
        LibraryMethods::Register(externs, resolver);
        WASMMoveDataRegistry::Register(externs, resolver);
    }
};

#endif // PKMNLIB_TYPEREGISTRY_HPP
